<script setup lang="ts">
import type { Promo } from '@/entities';
import { persistOrUpdate } from '@/form-helpers';
import { useFabriqueStore } from '@/stores/fabrique';
import { usePromoStore } from '@/stores/promo';
import type { FormInstance } from 'element-plus';
import { storeToRefs } from 'pinia';
import { onMounted, ref, watch } from 'vue';

const props = defineProps<{
    promo?: Promo
}>();
const emit = defineEmits(['cancel']);

const store = useFabriqueStore();
const { fabriques, selected } = storeToRefs(store);

const initialValue = {
    name: '',
    startDate: new Date(),
    endDate: new Date(),
    studentNumber: 0,
    fabrique: { ...selected.value }

}


const ruleFormRef = ref<FormInstance>()

const { persistPromo, updatePromo } = usePromoStore();


const newPromo = ref<Promo>({
    ...initialValue,
    ...props.promo
});

async function handleForm() {
    await persistOrUpdate(newPromo.value, updatePromo, persistPromo);
    newPromo.value = { ...initialValue };
}

onMounted(() => {
    store.fetchFabriques();
})

watch(() => props.promo, (value) => {

    if (value) {
        Object.assign(newPromo.value, value);
    } else {
        newPromo.value = { ...initialValue };
    }
});

const shortcuts = [
    {
        text: 'Today',
        value: new Date(),
    },
    {
        text: 'Yesterday',
        value: () => {
            const date = new Date()
            date.setTime(date.getTime() - 3600 * 1000 * 24)
            return date
        },
    },
    {
        text: 'A week ago',
        value: () => {
            const date = new Date()
            date.setTime(date.getTime() - 3600 * 1000 * 24 * 7)
            return date
        },
    },
]

</script>
    
    
<template>
        <el-form ref="ruleFormRef" :model="newPromo" status-icon>
            <el-form-item label="Fabrique" prop="fabrique">
                <el-select clearable filterable v-model="newPromo.fabrique" class="m-2"
                    placeholder="Sélectionner la région" size="large" value-key="id">
                    <el-option v-for="fabrique in fabriques" :label="fabrique.name" :value="fabrique" />
                </el-select>
            </el-form-item>
            <el-form-item label="Nom" prop="name">
                <el-input placeholder="Entrer un nom" v-model="newPromo.name" />
            </el-form-item>
            <el-form-item label="Date de début" prop="startDate">
                <el-date-picker class="date-picker" v-model="newPromo.startDate" type="date" format="YYYY/MM/DD"
                    value-format="YYYY-MM-DD" placeholder="Choisir la date de début" :shortcuts="shortcuts"
                    :size="'large'" />
            </el-form-item>
            <el-form-item label="Date de fin" prop="endDAte">
                <el-date-picker class="date-picker" v-model="newPromo.endDate" format="YYYY/MM/DD"
                    value-format="YYYY-MM-DD" type="date" placeholder="Choisir la date de fin" :shortcuts="shortcuts"
                    :size="'large'" />
            </el-form-item>
            <el-form-item label="Nombre d'apprenant·es" prop="studentNumber">
                <el-input placeholder="Nombre d'apprenant·es" type="number" v-model="newPromo.studentNumber" />
            </el-form-item>
            <el-form-item>
                <el-button type="primary" @click="handleForm()">
                    <span v-if="newPromo.id">Modifier</span>
                    <span v-if="!newPromo.id">Créer</span>
                </el-button>
                <el-button v-if="newPromo.id" type="info" @click="emit('cancel')">
                    Annuler
                </el-button>

            </el-form-item>
        </el-form>


</template>

<style>
.el-date-editor.el-input,
.el-date-editor.el-input__wrapper {
    width: 100%;
}

.date-picker {
    display: flex;
    width: 100%;
}
</style>